---
comments: true
---

# 9.4. &nbsp; 小结

- 图由顶点和边组成，可以表示为一组顶点和一组边构成的集合。
- 相比线性关系（链表）和分治关系（树），网络关系（图）的自由度更高，也从而更为复杂。
- 有向图的边存在方向，连通图中的任意顶点都可达，有权图的每条边都包含权重变量。
- 邻接矩阵使用方阵来表示图，每一行（列）代表一个顶点，矩阵元素代表边，使用 $1$ 或 $0$ 来表示两个顶点之间有边或无边。邻接矩阵的增删查操作效率很高，但占用空间大。
- 邻接表使用多个链表来表示图，第 $i$ 条链表对应顶点 $i$ ，其中存储了该顶点的所有邻接顶点。邻接表相对邻接矩阵更加节省空间，但由于需要通过遍历链表来查找边，因此时间效率较低。
- 当邻接表中的链表过长时，可以将其转化为红黑树或哈希表，从而提升查询效率。
- 从算法思想角度分析，邻接矩阵体现“以空间换时间”，邻接表体现“以时间换空间”
- 图可以用于建模各类现实系统，例如社交网络、地铁线路等。
- 树是图的一种特例，树的遍历也是图的遍历的一种特例。
- 图的广度优先遍历是一种由近及远、层层扩张的搜索方式，常借助队列实现。
- 图的深度优先遍历是一种优先走到底、无路可走再回头的搜索方式，常基于递归来实现。
