---
comments: true
---

# 1.2. &nbsp; 算法是什么

## 1.2.1. &nbsp; 算法定义

「算法 Algorithm」是在有限时间内解决特定问题的一组指令或操作步骤。算法具有以下特性：

- 问题是明确的，需要拥有明确的输入和输出定义。
- 解具有确定性，即给定相同输入时，输出一定相同。
- 具有可行性，可在有限步骤、有限时间、有限内存空间下完成。
- 独立于编程语言，即可用多种语言实现。

## 1.2.2. &nbsp; 数据结构定义

「数据结构 Data Structure」是在计算机中组织与存储数据的方式。为了提高数据存储和操作性能，数据结构的设计原则有：

- 空间占用尽可能小，节省计算机内存。
- 数据操作尽量快，包括数据访问、添加、删除、更新等。
- 提供简洁的数据表示和逻辑信息，以便算法高效运行。

数据结构的设计是一个充满权衡的过程，这意味着如果获得某方面的优势，则往往需要在另一方面做出妥协。例如，链表相对于数组，数据添加删除操作更加方便，但牺牲了数据的访问速度；图相对于链表，提供了更多的逻辑信息，但需要占用更多的内存空间。

## 1.2.3. &nbsp; 数据结构与算法的关系

「数据结构」与「算法」是高度相关、紧密嵌合的，体现在：

- 数据结构是算法的底座。数据结构为算法提供结构化存储的数据，以及操作数据的对应方法。
- 算法是数据结构发挥的舞台。数据结构仅存储数据信息，结合算法才可解决特定问题。
- 算法有对应最优的数据结构。给定算法，一般可基于不同的数据结构实现，而最终执行效率往往相差很大。

![数据结构与算法的关系](what_is_dsa.assets/relationship_between_data_structure_and_algorithm.png)

<p align="center"> Fig. 数据结构与算法的关系 </p>

如果将「LEGO 乐高」类比到「数据结构与算法」，那么可以得到下表所示的对应关系。

<div class="center-table" markdown>

| 数据结构与算法 | LEGO 乐高                          |
| -------------- | ------------------------------- |
| 输入数据       | 未拼装的积木                        |
| 数据结构       | 积木组织形式，包括形状、大小、连接方式等 |
| 算法           | 把积木拼成目标形态的一系列操作步骤     |
| 输出数据       | 积木模型                           |

</div>

!!! tip "约定俗成的简称"

    在实际讨论中，我们通常会将「数据结构与算法」直接简称为「算法」。例如，我们熟称的 LeetCode 算法题目，实际上同时考察了数据结构和算法两部分知识。
